import os,sys 
from PyQt4.QtGui import *
from PyQt4.QtCore import *
import testPortSerieGUI
import serial
import ctypes  # An included library with Python install.

class MainDialog(QDialog,testPortSerieGUI.Ui_Dialog):
    def __init__(self,parent=None):
        super(MainDialog,self).__init__(parent)
        self.setupUi(self)
        self.logTimer = None
        # Identification des ports disponibles          
        #self.myPort = None
        for i in range(256):
            try:
                s = serial.Serial("COM"+str(i))
                self.cbPorts.addItem("COM"+str(i))
                s.close()
            except serial.SerialException:
                pass
        
    def openPort(self):
        try:
            # Choix du port dans la liste box
            myPort = self.cbPorts.currentIndex()
            # Ouverture du port choisi
            self.port = serial.Serial(myPort, baudrate=9600, timeout=1)
            ctypes.windll.user32.MessageBoxA(0, "Connecter !", "Serial Port", 0)
            # Activation des controles
            self.pbConnexion.setEnabled(False)
            self.pbDeconnexion.setEnabled(True)
            self.lineEdit.setEnabled(True)
            self.pbTransmettre.setEnabled(True)
            self.groupBox.setEnabled(True)
            # Demarage du timer
            self.logTimer = QTimer()
            QObject.connect(self.logTimer, SIGNAL("timeout()"),self.checkBuffer)
            self.logTimer.start(100) 
        # En cas d'echec d'ouverture du port    
        except serial.SerialException:
                ctypes.windll.user32.MessageBoxA(0, "Non connecter !", "Serial Port", 0)
                pass
        
    def pbDeconnexionClicked(self):
        self.port.close()
        self.pbDeconnexion.setEnabled(False)
        self.pbConnexion.setEnabled(True)
        self.lineEdit.setEnabled(False)
        self.pbTransmettre.setEnabled(False)
        self.groupBox.setEnabled(False)
        ctypes.windll.user32.MessageBoxA(0, "Non connecter", "Serial Port", 0)
        
    def pbTransmettreClicked(self):
        self.port.write(self.lineEdit.text()+"\r\n")
    
    def checkBuffer(self):
        try:
            # Lecture des caracteres en attente
            myline = self.port.read(self.port.inWaiting())
            if(myline<>""):
                # Ajout des caracteres recus dans la textbox
                self.teRecu.append(myline)
        except serial.SerialException:
            pass
        else:
            pass
        
app=QApplication(sys.argv) 
form=MainDialog()
form.show()
app.exec_()