import os,sys 
from PyQt4.QtGui import *
from PyQt4.QtCore import *
from PyQt4 import QtCore, QtGui
import thermometreGUI
import serial
import ctypes  # An included library with Python install.

class MainDialog(QDialog,thermometreGUI.Ui_Dialog):
    def __init__(self,parent=None):
        super(MainDialog,self).__init__(parent)
        self.setupUi(self)
        self.logTimer = None
        # Identification des ports disponibles          
        #self.myPort = None
        for i in range(256):
            try:
                s = serial.Serial("COM"+str(i))
                self.cbPort.addItem("COM"+str(i))
                s.close()
            except serial.SerialException:
                pass
        
    def pbConnexionClicked(self):
        try:
            # Choix du port dans la liste box
            myPort = self.cbPort.currentIndex()
            # Ouverture du port choisi
            self.port = serial.Serial(myPort, baudrate=9600, timeout=2)
            ctypes.windll.user32.MessageBoxA(0, "Connecter !", "Serial Port", 0)
            # Activation des controles
            self.pbConnexion.setEnabled(False)
            self.pbDeconnexion.setEnabled(True)
            self.gbThermometre.setEnabled(True)
            
            # Demarage du timer
            self.logTimer = QTimer()
            QObject.connect(self.logTimer, SIGNAL("timeout()"),self.checkBuffer)
            self.logTimer.start(500) 
        # En cas d'echec d'ouverture du port    
        except serial.SerialException:
                ctypes.windll.user32.MessageBoxA(0, "Non connecter !", "Serial Port", 0)
                pass
        
    def pbDeconnexionClicked(self):
        self.port.close()
        self.pbDeconnexion.setEnabled(False)
        self.pbConnexion.setEnabled(True)
        self.gbThermometre.setEnabled(False)
        ctypes.windll.user32.MessageBoxA(0, "Non connecter", "Serial Port", 0)
        
    
    def checkBuffer(self):
        try:
            # Lecture des caracteres en attente
            myline = self.port.readline(self.port.inWaiting())
            if(myline<>""):
                print myline
                # Ajout des caracteres recus dans la textbox
                temp = float(myline)
                self.Thermo.setProperty("value", temp)
                if(temp<20):
                    self.Thermo.setFillColor(QtGui.QColor(0, 0, 255))
                else:
                    if(temp>25):
                        self.Thermo.setFillColor(QtGui.QColor(255, 0, 0))
                    else:
                        self.Thermo.setFillColor(QtGui.QColor(0, 255, 0))
                self.lcdDisplay.display(myline)
        except serial.SerialException:
            pass
        else:
            pass
        
app=QApplication(sys.argv) 
form=MainDialog()
form.show()
app.exec_()